<div class="sub-page-container">
  <!-- Title -->
  <h1>{{ 'parameter.turbine.title' | translate }}</h1>
  <mat-divider></mat-divider>

  <div class="sub-page-body" *ngIf="turbine | async; let turbineValues">
    <div class="left-container" *ngIf="$schema | async; let schema">
      <div class="grid">
        <!-- 
          Name
        -->
        <div class="grid-item name">
          <div class="title">
            <h2>
              {{ 'parameter.turbine.loadPre' | translate }}
            </h2>
          </div>
          <mat-form-field>
            <mat-select
              disableOptionCentering
              (selectionChange)="setPreDefinedTurbine($event)"
            >
              <mat-option
                *ngFor="let turbine of predefinedTurbines; let i = index"
                value="{{ i }}"
                >{{ turbine.name }}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </div>
        <!-- 
          Cut in Speed
        -->
        <div class="grid-item cut-in-speed">
          <div class="title">
            <h2>
              {{ 'parameter.turbine.cutInSpd' | translate }}
            </h2>
            <mat-icon
              [matTooltip]="'parameter.turbine.cutInSpdDescription' | translate"
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #cutInSpd
            [unit]="schema.turbine.properties.cut_in_speed.unit"
            [min]="schema.turbine.properties.cut_in_speed.minimum"
            [max]="schema.turbine.properties.cut_in_speed.maximum"
            [step]="schema.turbine.properties.cut_in_speed.step"
            [value]="turbineValues.cut_in_speed"
            (valueChange)="turbineValues.cut_in_speed = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Cut out Speed 
        -->
        <div class="grid-item cut-out-speed">
          <div class="title">
            <h2>
              {{ 'parameter.turbine.cutOutSpd' | translate }}
            </h2>
            <mat-icon
              [matTooltip]="
                'parameter.turbine.cutOutSpdDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #cutOutSpd
            [unit]="schema.turbine.properties.cut_out_speed.unit"
            [min]="schema.turbine.properties.cut_out_speed.minimum"
            [max]="schema.turbine.properties.cut_out_speed.maximum"
            [step]="schema.turbine.properties.cut_out_speed.step"
            [value]="turbineValues.cut_out_speed"
            (valueChange)="turbineValues.cut_out_speed = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Hub Height
        -->
        <div class="grid-item hub-height">
          <div class="title">
            <h2>
              {{ 'parameter.turbine.hubHeight' | translate }}
            </h2>
            <mat-icon
              [matTooltip]="
                'parameter.turbine.hubHeightDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #hubHeight
            [unit]="schema.turbine.properties.hub_height.unit"
            [min]="schema.turbine.properties.hub_height.minimum"
            [max]="schema.turbine.properties.hub_height.maximum"
            [step]="schema.turbine.properties.hub_height.step"
            [value]="turbineValues.hub_height"
            (valueChange)="turbineValues.hub_height = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Rotor Diameter
        -->
        <div class="grid-item rotor-diameter">
          <div class="title">
            <h2>
              {{ 'parameter.turbine.rotorDiameter' | translate }}
            </h2>
            <mat-icon
              [matTooltip]="
                'parameter.turbine.rotorDiameterDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #rotorDiameter
            [unit]="schema.turbine.properties.rotor_diameter.unit"
            [min]="schema.turbine.properties.rotor_diameter.minimum"
            [max]="schema.turbine.properties.rotor_diameter.maximum"
            [step]="schema.turbine.properties.rotor_diameter.step"
            [value]="turbineValues.rotor_diameter"
            (valueChange)="turbineValues.rotor_diameter = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          ct Table
        -->
        <div class="grid-item ct-table">
          <div class="title">
            <h2>
              {{ 'parameter.turbine.ctTable' | translate }}
            </h2>
            <mat-icon
              [matTooltip]="'parameter.turbine.ctTableDescription' | translate"
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <table class="mat-table">
            <thead>
              <th class="mat-header-cell">
                {{ 'parameter.turbine.windSpeed' | translate }}
              </th>
              <th class="mat-header-cell">
                {{ 'parameter.turbine.ctValue' | translate }}
              </th>
              <th class="mat-header-cell">
                {{ 'parameter.turbine.remove' | translate }}
              </th>
            </thead>
            <tbody>
              <ng-template #ctTableBody> </ng-template>
            </tbody>
          </table>
          <button
            mat-button
            type="submit"
            class="stroked-pill-button"
            (click)="addCtPair()"
          >
            <mat-icon>add</mat-icon>
          </button>
        </div>
        <!-- 
          Power Table
        -->
        <div class="grid-item power-table">
          <div class="title">
            <h2>
              {{ 'parameter.turbine.pwrTable' | translate }}
            </h2>
            <mat-icon
              [matTooltip]="'parameter.turbine.pwrTableDescription' | translate"
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <table class="mat-table">
            <thead>
              <th class="mat-header-cell">
                {{ 'parameter.turbine.windSpeed' | translate }}
              </th>
              <th class="mat-header-cell">
                {{ 'parameter.turbine.pwrValue' | translate }}
              </th>
              <th class="mat-header-cell">
                {{ 'parameter.turbine.remove' | translate }}
              </th>
            </thead>
            <tbody>
              <ng-template #pwrTableBody> </ng-template>
            </tbody>
          </table>
          <button
            mat-button
            type="submit"
            class="stroked-pill-button"
            (click)="addPwrPair()"
          >
            <mat-icon>add</mat-icon>
          </button>
        </div>
      </div>
      <!-- 
        Save Button
      -->
      <button
        mat-button
        class="pill-button save-button"
        [disabled]="
          !buttonValidator([
            turbineValues.cut_in_speed,
            turbineValues.cut_out_speed,
            turbineValues.rotor_diameter,
            turbineValues.hub_height
          ])
        "
        (click)="onSave()"
      >
        {{ 'parameter.general.save' | translate }}
      </button>
    </div>

    <div class="right-container">
      <energy-platform-three-windflower-preview
        class="three-js"
        [hubHeight]="undefined"
        [rotorDiameter]="undefined"
      ></energy-platform-three-windflower-preview>
    </div>
  </div>
</div>
